%define ALD_Ver		2.0
%define PythonVer 3.10

Name:         python%{PythonVer}-libxml2

License:      MIT
Summary:      Python3 bindings for the libxml2 library
Version:      2.9.12
Release:      0

Source: libxml2-%{version}.tar.xz

Requires: python%{PythonVer}
Requires: libxml2 = %{version}-%{release}

%define DestDir		/Compiler/python/%{PythonVer}
# -----------------------------------------------------

%if %{_target_cpu} == %{_build_cpu}
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}
%define _CROSS 0
%define MakeLocCross 0
%else
# rpm --target=armv7hl -ba xxxxx.spec
%define _srcrpmdir	%{_topdir}/SRPMS/tmp
%define _CROSS 1
%define MakeLocCross 1
%define _host %{_arch}-%{_os}%{_gnu}
%endif
# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%endif

#------------------ CROSS DIR --------------------

%if "%{PythonVer}" != "%(v=`python3 -V`; v=${v#* } ; v=${v%.*} ; echo "$v")"
ERROR: PythonVer %(v=`python3 -V`; v=${v#* } ; v=${v%.*} ; echo "$v") != %{PythonVer}
%endif

%define docdir		%{_defaultdocdir}/%{name}
%define platlib		%{_libdir}/python%{PythonVer}/site-packages

%define auto_local %{_sourcedir}/AUTO_LOCAL-1.sh
%define have_auto_local %(if test -x %{auto_local} ; then echo 1 ; else echo 0 ; fi)

%if %{have_auto_local}
%define __os_install_post %{nil}
%define CrossPath	%(%{auto_local} -GetCrossPath -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu})
%endif

# ------------------- description ------------------------------------
%description
Python3 bindings for the libxml2 library
#-------------------------------
%package py
Summary:      python source code
%description py
These libraries are needed to compile python3 code.

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n libxml2-%{version}

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i586 -mpreferred-stack-boundary=3 -falign-functions=4 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
%endif
%if %{_arch} == "arm"
OPTFLAGS="%{optflags} -O2 -munaligned-access"
%endif

OPTFLAGS="$OPTFLAGS -fno-asynchronous-unwind-tables -fno-stack-protector"

CFLAGS="$OPTFLAGS -D_GNU_SOURCE -std=gnu99"
CXXFLAGS="$OPTFLAGS"
LDFLAGS="-Wl,--gc-sections"

%configure  \
	--with-python=/usr/bin/python3 \
	--disable-libtool-lock \
	&>Fconfigure_log.txt

make V=1 &>Fmake_log.txt

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
export PATH="%{CrossPath}/bin:$PATH"
export GCC_NoHostPath=d
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
rm -r $RPM_BUILD_ROOT%{_bindir}
rm -r $RPM_BUILD_ROOT%{_includedir}
rm -r $RPM_BUILD_ROOT%{_libdir}/cmake
rm -r $RPM_BUILD_ROOT%{_libdir}/pkgconfig
rm $RPM_BUILD_ROOT%{_libdir}/libxml2*
rm $RPM_BUILD_ROOT%{_libdir}/xml2Conf.sh
rm $RPM_BUILD_ROOT%{platlib}/*.a
rm $RPM_BUILD_ROOT%{platlib}/*.la
rm -r $RPM_BUILD_ROOT%{_datadir}

python3 -OO -c 'import compileall, re, sys; sys.exit (not compileall.compile_dir("'"$RPM_BUILD_ROOT%{platlib}"'", quiet=1))'
%{_rpmconfigdir}/python_install_opti.sh %{PythonVer} %{platlib} -use-O2


%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu}
%endif  # have_auto_local

# ------------------- Clean ------------------------------------------
%Clean

%if %{have_auto_local}
  %{auto_local} -build_cpu=%{_build_cpu} -target_cpu=%{_target_cpu} \
	-ALD_Ver=%{ALD_Ver} -RpmMovePath=%{DestDir} -tar_arg=bzip2
%endif  # have_auto_local

# ------------------- Files ------------------------------------------
%files
%{platlib}/*.so
%{platlib}/*.pyc

%files py
%{platlib}/*.py
